package jp.co.thinkit.employee.aop;

import org.aopalliance.intercept.MethodInterceptor;
import org.aopalliance.intercept.MethodInvocation;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class TraceAdvice implements MethodInterceptor {
    
	// Ȍ͉fIȊ֐Sł
    private static final Log log = LogFactory.getLog(TraceAdvice.class);
    
	public Object invoke(MethodInvocation invocation) throws Throwable {
		String methodName = invocation.getMethod().getName();
		String className = invocation.getThis().getClass().getName();
	    
		// OɁAustart \bh of class [NX]v̕o
		log.trace("*** Start : " + methodName
				+ "' of class [" + className + "]");
		
		// \bhsAʂێ
		Object ret = invocation.proceed();
		
		// OɁAustart \bh of class [NX]v̕o
		log.trace("*** End : " + methodName
				+ "' of class [" + className + "]");

		return ret;
	}
}
